# FoundationClasses
TKernel
Resource

# Resource_Manager Class Reference

Defines a resource structure and its management methods.
.

`#include <Resource_Manager.hxx>`

Inheritance diagram for Resource_Manager:

[legend]

## Public Member Functions

Standard_EXPORT | Resource_Manager (const Standard_CString aName, const Standard_Boolean Verbose=Standard_False)
| Create a Resource manager. Attempts to find the two following files: $CSF_`aName`Defaults/aName $CSF_`aName`UserDefaults/aName and load them respectively into a reference and a user resource structure. .
Standard_EXPORT | Resource_Manager (const Standard_CString aName, TCollection_AsciiString &aDefaultsDirectory, TCollection_AsciiString &anUserDefaultsDirectory, const Standard_Boolean Verbose=Standard_False)
Standard_EXPORT Standard_Boolean | Save () const
| Save the user resource structure in the specified file. Creates the file if it does not exist. .
Standard_EXPORT Standard_Boolean | Find (const Standard_CString aResource) const
| returns True if the Resource does exist.
virtual Standard_EXPORT Standard_Integer | Integer (const Standard_CString aResourceName) const
| Gets the value of an integer resource according to its instance and its type. .
virtual Standard_EXPORT Standard_Real | Real (const Standard_CString aResourceName) const
| Gets the value of a real resource according to its instance and its type. .
virtual Standard_EXPORT Standard_CString | Value (const Standard_CString aResourceName) const
| Gets the value of a CString resource according to its instance and its type. .
virtual Standard_EXPORT Standard_ExtString | ExtValue (const Standard_CString aResourceName)
| Gets the value of an ExtString resource according to its instance and its type. .
virtual Standard_EXPORT void | SetResource (const Standard_CString aResourceName, const Standard_Integer aValue)
| Sets the new value of an integer resource. If the resource does not exist, it is created. .
virtual Standard_EXPORT void | SetResource (const Standard_CString aResourceName, const Standard_Real aValue)
| Sets the new value of a real resource. If the resource does not exist, it is created. .
virtual Standard_EXPORT void | SetResource (const Standard_CString aResourceName, const Standard_CString aValue)
| Sets the new value of an CString resource. If the resource does not exist, it is created. .
virtual Standard_EXPORT void | SetResource (const Standard_CString aResourceName, const Standard_ExtString aValue)
| Sets the new value of an ExtString resource. If the resource does not exist, it is created. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Private Member Functions

Standard_EXPORT void | Load (TCollection_AsciiString &aDirectory, TCollection_AsciiString &aName, Resource_DataMapOfAsciiStringAsciiString &aMap)

## Private Attributes

TCollection_AsciiString | myName
Resource_DataMapOfAsciiStringAsciiString | myRefMap
Resource_DataMapOfAsciiStringAsciiString | myUserMap
Resource_DataMapOfAsciiStringExtendedString | myExtStrMap
Standard_Boolean | myVerbose

## Constructor & Destructor Documentation

Standard_EXPORT Resource_Manager::Resource_Manager | ( | const Standard_CString | aName,
|  | const Standard_Boolean | Verbose = `Standard_False`
| ) |

Standard_EXPORT Resource_Manager::Resource_Manager | ( | const Standard_CString | aName,
|  | TCollection_AsciiString & | aDefaultsDirectory,
|  | TCollection_AsciiString & | anUserDefaultsDirectory,
|  | const Standard_Boolean | Verbose = `Standard_False`
| ) |

## Member Function Documentation

virtual Standard_EXPORT Standard_ExtString Resource_Manager::ExtValue | ( | const Standard_CString | aResourceName | ) | `[virtual]`

Standard_EXPORT Standard_Boolean Resource_Manager::Find | ( | const Standard_CString | aResource | ) | const

Standard_EXPORT const Resource_Manager::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from MMgt_TShared.

virtual Standard_EXPORT Standard_Integer Resource_Manager::Integer | ( | const Standard_CString | aResourceName | ) | const`[virtual]`

Standard_EXPORT void Resource_Manager::Load | ( | TCollection_AsciiString & | aDirectory,
|  | TCollection_AsciiString & | aName,
|  | Resource_DataMapOfAsciiStringAsciiString & | aMap
| ) | `[private]`

virtual Standard_EXPORT Standard_Real Resource_Manager::Real | ( | const Standard_CString | aResourceName | ) | const`[virtual]`

Standard_EXPORT Standard_Boolean Resource_Manager::Save | ( |  | ) | const

virtual Standard_EXPORT void Resource_Manager::SetResource | ( | const Standard_CString | aResourceName,
|  | const Standard_ExtString | aValue
| ) | `[virtual]`

virtual Standard_EXPORT void Resource_Manager::SetResource | ( | const Standard_CString | aResourceName,
|  | const Standard_CString | aValue
| ) | `[virtual]`

virtual Standard_EXPORT void Resource_Manager::SetResource | ( | const Standard_CString | aResourceName,
|  | const Standard_Real | aValue
| ) | `[virtual]`

virtual Standard_EXPORT void Resource_Manager::SetResource | ( | const Standard_CString | aResourceName,
|  | const Standard_Integer | aValue
| ) | `[virtual]`

virtual Standard_EXPORT Standard_CString Resource_Manager::Value | ( | const Standard_CString | aResourceName | ) | const`[virtual]`

## Field Documentation

Resource_DataMapOfAsciiStringExtendedString Resource_Manager::myExtStrMap `[private]`

TCollection_AsciiString Resource_Manager::myName `[private]`

Resource_DataMapOfAsciiStringAsciiString Resource_Manager::myRefMap `[private]`

Resource_DataMapOfAsciiStringAsciiString Resource_Manager::myUserMap `[private]`

Standard_Boolean Resource_Manager::myVerbose `[private]`

The documentation for this class was generated from the following file:

- Resource_Manager.hxx